#include "Wire.h"
#include "Adafruit_PWMServoDriver.h"
Adafruit_PWMServoDriver pwm = Adafruit_PWMServoDriver(0x40);

#define MIN_PULSE_WIDTH 600
#define MAX_PULSE_WIDTH 2600
#define FREQUENCY 80
int D = 150; //speed
void setup() {
  pwm.begin();
  pwm.setPWMFreq(FREQUENCY);
}

int pulseWidth(int angle) {
  int pulse_wide, analog_value;
  pulse_wide = map(angle, 0, 180, MIN_PULSE_WIDTH, MAX_PULSE_WIDTH);
  analog_value = int(float(pulse_wide) / 1000000 * FREQUENCY * 4096);
  return analog_value;
}

void loop() {
  // put your main code here, to run repeatedly:
  
  forward(true);   
  right();
  left ();
  stand();
  delay(2000);
}

void right() {
  pwm.setPWM(2, 0, pulseWidth(50)); delay(D);
  pwm.setPWM(3, 0, pulseWidth(120));delay(D);                                             //step22
  pwm.setPWM(2, 0, pulseWidth(10)); delay(D);
  pwm.setPWM(1, 0, pulseWidth(130)); delay(D);
  pwm.setPWM(0, 0, pulseWidth(160)); delay(D);
  pwm.setPWM(6, 0, pulseWidth(100)); delay(D);
  pwm.setPWM(7, 0, pulseWidth(140)); delay(D);
  pwm.setPWM(6, 0, pulseWidth(180)); delay(D);                                            //step4
  pwm.setPWM(4, 0, pulseWidth(60)); delay(D);
  pwm.setPWM(5, 0, pulseWidth(60)); delay(D);
  pwm.setPWM(4, 0, pulseWidth(0)); delay(D);
  pwm.setPWM(6, 0, pulseWidth(100)); delay(D);
  pwm.setPWM(7, 0, pulseWidth(30)); delay(D);                                             //step5
  pwm.setPWM(6, 0, pulseWidth(180)); delay(D);
  pwm.setPWM(7, 0, pulseWidth(140));
  pwm.setPWM(1, 0, pulseWidth(50)); delay(D);
  pwm.setPWM(3, 0, pulseWidth(30));                                              //mouve6
  pwm.setPWM(5, 0, pulseWidth(140));
}

void left () {
  pwm.setPWM(2, 0, pulseWidth(60)); delay(D);
  pwm.setPWM(3, 0, pulseWidth(30)); delay(D);
  pwm.setPWM(2, 0, pulseWidth(20)); delay(D);                                    //step1
  pwm.setPWM(0, 0, pulseWidth(100)); delay(D);
  pwm.setPWM(1, 0, pulseWidth(130)); delay(D);
  pwm.setPWM(0, 0, pulseWidth(160)); delay(D);
  pwm.setPWM(6, 0, pulseWidth(160)); delay(D);
  pwm.setPWM(7, 0, pulseWidth(100)); delay(D);
  pwm.setPWM(6, 0, pulseWidth(170)); delay(D);
  pwm.setPWM(2, 0, pulseWidth(60)); delay(D);
  pwm.setPWM(3, 0, pulseWidth(140)); delay(D);                                  //step2
  pwm.setPWM(2, 0, pulseWidth(10)); delay(D);
  pwm.setPWM(3, 0, pulseWidth(30));
  pwm.setPWM(5, 0, pulseWidth(150)); delay(D);
  pwm.setPWM(7, 0, pulseWidth(140));                                             //mouve3
  pwm.setPWM(1, 0, pulseWidth(50)); delay(D);
}
void stand () {
  pwm.setPWM(0, 0, pulseWidth(160));
  pwm.setPWM(1, 0, pulseWidth(90));
  pwm.setPWM(2, 0, pulseWidth(20));
  pwm.setPWM(3, 0, pulseWidth(90));
  pwm.setPWM(4, 0, pulseWidth(0));
  pwm.setPWM(5, 0, pulseWidth(90));
  pwm.setPWM(6, 0, pulseWidth(170));
  pwm.setPWM(7, 0, pulseWidth(90));
}

void forward( bool x) {
  while (x == true) {
    pwm.setPWM(2, 0, pulseWidth(60)); delay(D);
    pwm.setPWM(3, 0, pulseWidth(30)); delay(D);
    pwm.setPWM(2, 0, pulseWidth(20)); delay(D);                             //step1
    pwm.setPWM(0, 0, pulseWidth(100)); delay(D);
    pwm.setPWM(1, 0, pulseWidth(130)); delay(D);
    pwm.setPWM(0, 0, pulseWidth(160)); delay(D);
    pwm.setPWM(6, 0, pulseWidth(160)); delay(D);
    pwm.setPWM(7, 0, pulseWidth(100));      delay(D);                       //step11
    pwm.setPWM(6, 0, pulseWidth(170)); delay(D);
    pwm.setPWM(2, 0, pulseWidth(60)); delay(D);
    pwm.setPWM(3, 0, pulseWidth(140));   delay(D);                           //step2
    pwm.setPWM(2, 0, pulseWidth(10)); delay(D);
    pwm.setPWM(3, 0, pulseWidth(30));
    pwm.setPWM(5, 0, pulseWidth(150)); delay(D);
    pwm.setPWM(7, 0, pulseWidth(140));     //mouve3
    pwm.setPWM(1, 0, pulseWidth(50)); delay(D);
    pwm.setPWM(2, 0, pulseWidth(50)); delay(D);
    pwm.setPWM(3, 0, pulseWidth(120));     delay(D);                        //step22
    pwm.setPWM(2, 0, pulseWidth(10)); delay(D);                             //step4
    pwm.setPWM(4, 0, pulseWidth(60)); delay(D);
    pwm.setPWM(5, 0, pulseWidth(60)); delay(D);
    pwm.setPWM(4, 0, pulseWidth(0)); delay(D);
    pwm.setPWM(6, 0, pulseWidth(100)); delay(D);
    pwm.setPWM(7, 0, pulseWidth(30));      delay(D);                         //step5
    pwm.setPWM(6, 0, pulseWidth(180)); delay(D);
    pwm.setPWM(7, 0, pulseWidth(140));
    pwm.setPWM(1, 0, pulseWidth(50)); delay(D);
    pwm.setPWM(3, 0, pulseWidth(30));                                       //mouve6
    pwm.setPWM(5, 0, pulseWidth(140)); delay(D);
  }
}
